/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.0
 *
 * @date        2026-02-25
 *
 * @attention
 *
 *  Copyright (C) 2026 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (Geehy Semiconductor Software License Agreement).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the Geehy Semiconductor Software License Agreement for the governing permissions
 *  and limitations under the License.
 */

/* Includes */
#include "Board.h"
#include "g32a10xx_iwdt.h"
#include "stdio.h"
#include "g32a10xx_int.h"

/** @addtogroup Examples
  @{
  */

/** @addtogroup IWDT_Examples
  @{
*/

/** @addtogroup IWDT_FeedDog
  @{
  */

/** @defgroup IWDT_FeedDog_Macros Macros
  @{
  */

/* printf function configs to USART1*/
#define DEBUG_USART  USART1

/**@} end of group IWDT_FeedDog_Macros */

/** @defgroup IWDT_FeedDog_Variables Variables
  @{
*/

/* System tick */
volatile uint32_t g_sysTick = 0;

/**@} end of group IWDT_FeedDog_Variables */

/** @defgroup IWDT_FeedDog_Functions Functions
  @{
  */

/* delay */
void Iwdt_Delay_Ms(uint32_t xms);
/* IWDT init */
void Iwdt_Init(void);
/* IWDT Feed */
void Iwdt_Feed(void);

/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 *
 * @note
 */
int main(void)
{
    Board_LedInit(LED2);
    Board_LedInit(LED3);
    Board_ComInit(COM1);

    /* Configure the SysTick to generate a time base equal to 1 ms */
    if (SysTick_Config(SystemCoreClock / 1000U) != 0U)
    {
        while (1)
        {
            /* nothing */
        }
    }
    else
    {
        /* nothing */
    }
    Iwdt_Init();
    printf("System Reset\r\n");
    while (1)
    {
        Iwdt_Delay_Ms(2400);
        Board_LedToggle(LED2);
        Iwdt_Feed();
        printf("running\r\n");
    }
}


/*!
 * @brief       Iwdt_Delay_Ms
 *
 * @param       xms:  x ms
 *
 * @retval      None
 *
 * @note
 */
void Iwdt_Delay_Ms(uint32_t xms)
{
    uint32_t start = g_sysTick;

    while ((g_sysTick - start) < xms)
    {
        /* do nothing */
    }
}

/*!
 * @brief       IWDT Init
 *
 * @param       None
 *
 * @retval      None
 *
 * @note
 */
void Iwdt_Init(void)
{
    uint32_t timeout = 0xFFFF;

    /* clear IWDTRST Flag*/
    if (Rcm_ReadStatusFlag(RCM_FLAG_IWDTRST) != (uint16_t)RESET)
    {
        Rcm_ClearStatusFlag();
    }
    else
    {
        /* nothing */
    }
    /* Enable IWDT*/
    Iwdt_Enable();

    /* set IWDT Write Access */
    Iwdt_EnableWriteAccess();

    /* set IWDT Divider*/
    Iwdt_ConfigDivider(IWDT_DIV_64);

    while ((IWDT->STS_R.STS != 0U) && (timeout > 0U))
    {
        timeout = timeout - 1U;
    }

    /* set IWDT Reloader*/
    Iwdt_ConfigReload(40000 / 32);

    while ((IWDT->STS_R.STS != 0U) && (timeout > 0U))
    {
        timeout = timeout - 1U;
    }

    /* Refresh*/
    Iwdt_Refresh();

}

/*!
 * @brief       IWDT Feed Dog
 *
 * @param       None
 *
 * @retval      None
 *
 * @note
 */
void Iwdt_Feed(void)
{
    Iwdt_Refresh();
}
#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*
* @note
*/
int fputc(int ch, FILE* f)
{
    /* send a byte of data to the serial port */
    Usart_TxData(DEBUG_USART, (uint8_t)ch);

    /* wait for the data to be send  */
    while (Usart_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == (uint8_t)RESET)
    {
        /* nothing */
    }

    return (ch);
}

#elif defined (__GNUC__)

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @retval      The characters that need to be send.
*
* @note
*/
int __io_putchar(int ch)
{
    /* send a byte of data to the serial port */
    Usart_TxData(DEBUG_USART, ch);

    /* wait for the data to be send  */
    while (Usart_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return ch;
}

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       file:  Meaningless in this function.
*
* @param       *ptr:  Buffer pointer for data to be sent.
*
* @param       len:  Length of data to be sent.
*
* @retval      The characters that need to be send.
*
* @note
*/
int _write(int file, char* ptr, int len)
{
    int i;
    for (i = 0; i < len; i++)
    {
        __io_putchar(*ptr++);
    }

    return len;
}

#else
#pragma message("Not supported compiler type")
#endif

/**@} end of group IWDT_FeedDog_Functions */
/**@} end of group IWDT_FeedDog */
/**@} end of group IWDT_Examples */
/**@} end of group Examples */
